#include "usgard.h"
 .org 0
 .db "TOUCHE COULE v2.2 par Joa",0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;aliases
nb	=TEXT_MEM	;1 byte mais TEXT_MEM+1 doit etre egal  0
case	=TEXT_MEM+2	;1 byte mais TEXT_MEM+3 doit etre egal  0
let	=TEXT_MEM+4	;1 byte mais TEXT_MEM+5 doit etre egal  0
chif	=TEXT_MEM+6	;1 byte mais TEXT_MEM+6 doit etre egal  0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;dbut du programme
start:
	ld hl,VIDEO_MEM
	ld (DEST_ADDR),hl
	ld de,0
	ld (case),de
        ld (nb),de
	ld (let),de
	ld (chif),de
	ld hl,&tour
	ld a,(hl)
	ld (nb),a
	call CLEARLCD
	ld hl,&titreS
	ld de,$0202
	ld (CURSOR_ROW),de
	call D_ZT_STR
	ld de,$0007	
	ld (CURSOR_ROW),de
	call D_ZT_STR
waitkey:
	call &waitfor_a_key_pressed
	cp K_F1
	jr z,nouvelle_partie
	cp K_F5
	jr z,resume
	jr waitkey	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
nouvelle_partie:	;remise a zero de tout pour une nouvelle partie
	call CLEARLCD
	ld hl,VIDEO_MEM	
	ld de,&grille_a
	ld bc,400
	ldir
	ld hl,&bateau_par_default
	ld de,&bateau_a
	ld bc,10
	ldir
	ld hl,&tour
	ld (hl),3
	inc hl
	inc hl
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;joueur A
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&joueura
	call D_ZT_STR		
	call &waitfor_a_key_pressed	
	ld de,1
	ld (nb),de
	call &choix_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;joueur B
	call CLEARLCD
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&joueurb
	call D_ZT_STR		
	call &waitfor_a_key_pressed
	ld de,2
	ld (nb),de	
	call &choix_code
	ld hl,&tour
	ld (hl),1
	ld a,1
	ld (nb),a

resume:
	ld a,(nb)
	cp 3
        jp z,&start
	cp 2
	jr z,play_init_b
play_init_a:
	call CLEARLCD
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&joueura
	call D_ZT_STR
	call &waitfor_a_key_pressed
	jr verif_code
play_init_b:
	call CLEARLCD
	ld hl,$0703
	ld (CURSOR_ROW),hl
	ld hl,&joueurb
	call D_ZT_STR
	call &waitfor_a_key_pressed

verif_code:
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&entercodeS
	call D_ZT_STR
	call D_ZT_STR
	call D_ZT_STR
	call D_ZT_STR
	call D_ZT_STR

verif_code_deux:
	ld de,(nb)
	ld hl,&tour
	add hl,de
	ld c,(hl)
	inc hl
	inc hl
	ld a,(hl)
	ld de,$0004
	ld (CURSOR_ROW),de		;affiche le nombre d'essai restant
	#fncall D_a_dec
	call &waitfor_a_key_pressed	;a = touche press (code)
	cp c
	jr z,play
	ld a,(hl)
	dec a
	jp z,&partie_fin	;les 3 essais sont faux la partie est detruite
	ld (hl),a
	ld de,$0004
	ld (CURSOR_ROW),de
	jr verif_code_deux

play:
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&codecorrectS
	call D_ZT_STR
	call &waitfor_a_key_pressed
play_deux:
	call &grille_aoub
	call &affichage
	push hl
	call CLEARLCD
	ld hl,$3A00
	ld ($8333),hl
	ld hl,&cibleS
	call D_ZM_STR	;affiche &cible tout en bas de l'cran
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop hl
	ld de,100
	add hl,de	;pointe hl  &grille_tir_a ou &grille_tir_b
	ld bc,$4200	;coordonn de la premire case de la grille de tir
	ld de,0
	ld (case),de
	call &put_viseur
	call &deplacement_viseur_deux
	push hl
	call &grille_adverse_aoub
	ld de,(case)
	add hl,de
	ld a,(hl)
	or a
	jr z,dans_leau
	cp 3
	jr z,porte_touche
	cp 4
	jr z,cuirasse_touche
	cp 5
	jr z,croiser_touche
	cp 6
	jr z,sous_touche
	cp 7
        jp z,&destroyer_touche

dans_leau:
	ld (hl),1
	pop hl
	ld (hl),1
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&dansleauS
	call D_ZT_STR
	call &change_tour
	call &waitfor_a_key_pressed
        jp &resume
porte_touche:
	ld (hl),2	; met 2 (c'est a dire touch) dans la grille adverse
	pop hl
	ld (hl),2	;et dans la grille de tir du joueur
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&porteS
	call D_ZT_STR
	call &bateau_adverse_aoub	;reourne dans (hl) le nombre de case restante pour ce bateau
	jr disp_touche
cuirasse_touche:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&cuirasseS
	call D_ZT_STR
	call &bateau_adverse_aoub
	inc hl
	jr disp_touche
croiser_touche:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&croiserS
	call D_ZT_STR
	call &bateau_adverse_aoub
	inc hl
	inc hl
	jr disp_touche
sous_touche:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&sousS
	call D_ZT_STR
	call &bateau_adverse_aoub
	inc hl
	inc hl
	inc hl
	jr disp_touche
destroyer_touche:
	ld (hl),2
	pop hl
	ld (hl),2
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&destroyerS
	call D_ZT_STR
	call &bateau_adverse_aoub
	inc hl
	inc hl
	inc hl
	inc hl
disp_touche:
	push hl
	ld hl,1
	ld (CURSOR_ROW),hl
	ld hl,&toucheS
	call D_ZT_STR
	pop hl
	dec (hl)
	jr z,disp_coule
	call &waitfor_a_key_pressed
        jp &play_deux
disp_coule:
	ld hl,&couleS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &bateau_adverse_aoub
	ld a,(hl)
	inc hl
	add a,(hl)
	inc hl
	add a,(hl)
	inc hl
	add a,(hl)
	inc hl
	add a,(hl)
	or a			;verifie si touts les bateau ont t coul
        jp nz,&play_deux
	ld hl,$0104
	ld (CURSOR_ROW),hl
	ld hl,&winS
	call D_ZT_STR
partie_fin:
	ld hl,&tour
	ld (hl),3		;3=ne peut recharger la partie
	call &waitfor_a_key_pressed
	call &exit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
choix_code:
	call CLEARLCD
	ld hl,0
	ld (CURSOR_ROW),hl
	ld hl,&presskeycodeS
	call D_ZT_STR
	call D_ZT_STR
	call &waitfor_a_key_pressed	;a = le code
	ld hl,&tour
	ld de,(nb)
	add hl,de
	ld (hl),a		;memorisation du code dans &tour+1 ou +2

place_porte:	;preparation pour placer le porte-avion
	call CLEARLCD
	ld hl,$0403
	ld (CURSOR_ROW),hl
	ld hl,&porteS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &grille_aoub	;hl =&grille a ou b?
	call &affichage
	call &disp_premiere_caseS
	ld bc,0	;x,y de la 1er case
	call &put_viseur	; affiche le viseur et la lettre et le chiffre
	call &deplacement_viseur_deux	;deplace le viseur, hl et bc sont adapt
	call &disp_doubS
place_porte_doub:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,place_porte_droite
	cp K_DOWN
	jr z,place_porte_bas
	cp K_SECOND
	jr z,place_porte	;si le joueur ne veux finalement pas le placer l
	cp K_EXIT
	call z,&exit
	jr place_porte_doub
place_porte_droite:
	ld a,b
	add a,24
	cp 55
	jr nc,place_porte	;verif si il y a assez de cases pour placer le bateau
	ld b,4		;taille du bateau - 1
	call &place_bateau_droite_verif	;verif si il n'y a pas d'autres bateau sur le chemin(a=0 ou 1)
	or a		;si a=0 on peut le mettre sinon on ne peut pas
	jr nz,place_porte
	dec hl		;revenir a la 1er case
	dec hl
	dec hl
	dec hl
	ld (hl),3	;met le "bateau" dans la grille (a ou b)
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
	inc hl
	ld (hl),3
	jr place_cuirasse	;passe au bateau suivant
place_porte_bas:
	ld a,c
	add a,24
	cp 55
	jr nc,place_porte
	ld b,4
	call &place_bateau_bas_verif
	or a
	jr nz,place_porte
	or a
	ld de,40
	sbc hl,de
	ld de,10
	ld (hl),3
	add hl,de
	ld (hl),3
	add hl,de
	ld (hl),3
	add hl,de
	ld (hl),3
	add hl,de
	ld (hl),3

place_cuirasse:
	call CLEARLCD
	ld hl,$0603
	ld (CURSOR_ROW),hl
	ld hl,&cuirasseS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &grille_aoub
	call &affichage
	call &disp_premiere_caseS
	ld bc,0
	call &put_viseur
	call &deplacement_viseur_deux	
	call &disp_doubS
place_cuirasse_doub:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,place_cuirasse_droite
	cp K_DOWN
	jr z,place_cuirasse_bas
	cp K_SECOND
	jr z,place_cuirasse
	cp K_EXIT
	call z,&exit
	jr place_cuirasse_doub
place_cuirasse_droite:
	ld a,b
	add a,18
	cp 55
	jr nc,place_cuirasse
	ld b,3
	call &place_bateau_droite_verif
	or a
	jr nz,place_cuirasse
	dec hl
	dec hl
	dec hl
	ld (hl),4
	inc hl
	ld (hl),4
	inc hl
	ld (hl),4
	inc hl
	ld (hl),4
	jr place_croiser
place_cuirasse_bas:
	ld a,c
	add a,18
	cp 55
	jr nc,place_cuirasse
	ld b,3
	call &place_bateau_bas_verif
	or a
	jr nz,place_cuirasse
	or a
	ld de,30
	sbc hl,de
	ld de,10
	ld (hl),4
	add hl,de
	ld (hl),4
	add hl,de
	ld (hl),4
	add hl,de
	ld (hl),4

place_croiser:
	call CLEARLCD
	ld hl,$0603
	ld (CURSOR_ROW),hl
	ld hl,&croiserS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &grille_aoub	
	call &affichage
	call &disp_premiere_caseS
	ld bc,0
	call &put_viseur
	call &deplacement_viseur_deux	
	call &disp_doubS
place_croiser_doub:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,place_croiser_droite
	cp K_DOWN
	jr z,place_croiser_bas
	cp K_SECOND
	jr z,place_croiser
	cp K_EXIT
	call z,&exit
	jr place_croiser_doub
place_croiser_droite:
	ld a,b
	add a,12
	cp 55
	jr nc,place_croiser
	ld b,2
	call &place_bateau_droite_verif
	or a
	jr nz,place_croiser
	dec hl
	dec hl
	ld (hl),5
	inc hl
	ld (hl),5
	inc hl
	ld (hl),5
	jr place_sous
place_croiser_bas:
	ld a,c
	add a,12
	cp 55
	jr nc,place_croiser
	ld b,2
	call &place_bateau_bas_verif
	or a
	jr nz,place_croiser
	or a
	ld de,20
	sbc hl,de
	ld de,10
	ld (hl),5
	add hl,de
	ld (hl),5
	add hl,de
	ld (hl),5

place_sous:
	call CLEARLCD
	ld hl,$0403
	ld (CURSOR_ROW),hl
	ld hl,&sousS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &grille_aoub	
	call &affichage
	call &disp_premiere_caseS
	ld bc,0
	call &put_viseur
	call &deplacement_viseur_deux
	call &disp_doubS
place_sous_doub:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,place_sous_droite
	cp K_DOWN
	jr z,place_sous_bas
	cp K_SECOND
	jr z,place_sous
	cp K_EXIT
	call z,&exit
	jr place_sous_doub
place_sous_droite:
	ld a,b
	add a,12
	cp 55
	jr nc,place_sous
	ld b,2
	call &place_bateau_droite_verif
	or a
	jr nz,place_sous
	dec hl
	dec hl
	ld (hl),6
	inc hl
	ld (hl),6
	inc hl
	ld (hl),6
	jr place_destroyer
place_sous_bas:
	ld a,c
	add a,12
	cp 55
	jr nc,place_sous
	ld b,2
	call &place_bateau_bas_verif
	or a
	jr nz,place_sous
	or a
	ld de,20
	sbc hl,de
	ld de,10
	ld (hl),6
	add hl,de
	ld (hl),6
	add hl,de
	ld (hl),6

place_destroyer:
	call CLEARLCD
	ld hl,$0503
	ld (CURSOR_ROW),hl
	ld hl,&destroyerS
	call D_ZT_STR
	call &waitfor_a_key_pressed
	call &grille_aoub
	call &affichage
	call &disp_premiere_caseS
	ld bc,0
	call &put_viseur
	call &deplacement_viseur_deux	
	call &disp_doubS
place_destroyer_doub:	
	push hl
	call GET_KEY
	pop hl
	cp K_RIGHT
	jr z,place_destroyer_droite
	cp K_DOWN
	jr z,place_destroyer_bas
	cp K_SECOND
	jr z,place_destroyer
	cp K_EXIT
	call z,&exit
	jr place_destroyer_doub
place_destroyer_droite:
	ld a,b
	add a,6
	cp 55
	jr nc,place_destroyer
	ld b,1
	call &place_bateau_droite_verif
	or a
	jr nz,place_destroyer
	dec hl
	ld (hl),7
	inc hl
	ld (hl),7
	ret
place_destroyer_bas:
	ld a,c
	add a,6
	cp 55
	jr nc,place_destroyer
	ld b,1
	call &place_bateau_bas_verif
	or a
	jr nz,place_destroyer
	or a
	ld de,10
	sbc hl,de
	ld de,10
	ld (hl),7
	add hl,de
	ld (hl),7
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
exit:
	ld hl,GRAPH_MEM
	ld bc,1023
	call OTH_CLEAR
	call OTH_EXIT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;differents sous-programmes
waitfor_a_key_pressed:		; attend qu'une touche soit press ou quitte le programme si exit est press
	push hl			;ou retourne dans a la touche press
	call GET_KEY
	pop hl
	or a
	jr z,waitfor_a_key_pressed
	cp K_EXIT
	call z,&exit
	ret
put_viseur:		;affiche le viseur b=x coordonn ,c=y coordonn
	push hl
	push bc
	ld hl,&viseur
	#fncall Pspr_w
	ld a,5
	ld hl,$FFBE
clear:		;efface en bas a droite la lettre et le chiffre
	ld (hl),0
	inc hl
	ld (hl),0
	ld de,15
	add hl,de
	dec a
	jr nz,clear	
	ld hl,$3A72
	ld ($8333),hl
	ld hl,&chiffres
	ld de,(chif)
	add hl,de
	ld a,(hl)
	#fncall Dm_a_dec
	ld hl,$3A71
	ld ($8333),hl
	ld hl,&lettres
	ld de,(let)
	add hl,de
	ld a,(hl)
	call M_CHARPUT
	ld hl,GRAPH_MEM+941
	ld de,VIDEO_MEM+941
	ld bc,3
	ldir		;copie le petit bout de grille effac
	pop bc
	pop hl
	ret

grille_aoub:		;pointe hl  la grille du joueur courant
	ld a,(nb)
	cp 1
	jr z,grille_aoub_a
	ld hl,&grille_b
	ret
grille_aoub_a:
	ld hl,&grille_a
	ret

grille_adverse_aoub:	;pointe hl  la grille du joueur adverse
	ld a,(nb)
	cp 1
	jr z,grille_adverse_aoub_b
	ld hl,&grille_a
	ret
grille_adverse_aoub_b:
	ld hl,&grille_b
	ret

bateau_adverse_aoub:	;pointe hl au bateau restant du joueur adverse
	ld a,(nb)
	cp 1
	jr z,bateau_adverse_aoub_b
	ld hl,&bateau_a
	ret
bateau_adverse_aoub_b:
	ld hl,&bateau_b
	ret
change_tour:
	ld hl,&tour
	ld a,(nb)
	cp 1
	jr z,change_tour_a
	dec a
	ld (nb),a
	ld (hl),1
	ret
change_tour_a:
	inc a
	ld (nb),a
	ld (hl),2
	ret
	

disp_premiere_caseS:
	push hl
	call CLEARLCD
	ld hl,$3A00
	ld ($8333),hl
	ld hl,&premiere_caseS
	call D_ZM_STR
	ld hl,$GRAPH_MEM
	ld de,$VIDEO_MEM
	ld bc,944
	ldir
	ld de,0
	pop hl
	ret
disp_doubS:
	push hl
	push bc
	ld hl,$3A00
	ld ($8333),hl
	ld hl,&doubS
	call D_ZM_STR
	pop bc
	pop hl
	ret

place_bateau_droite_verif:
	inc hl
	ld a,(hl)
	or a
	ret nz
	djnz place_bateau_droite_verif
	ret

place_bateau_bas_verif:
	ld de,10
	add hl,de
	ld a,(hl)
	or a
	ret nz
	djnz place_bateau_bas_verif
	ret


deplacement_viseur_deux:	;deplace le viseur et pointe hl a la bonne case dans &grilleX
	call &deplacement_viseur
	ld a,(hl)
	or a
	jr nz,deplacement_viseur_deux
	ret
deplacement_viseur:
	push hl
	call GET_KEY
	pop hl
	cp K_DOWN
	call z,&dv_enbas
	cp K_LEFT
	call z,&dv_agauche
	cp K_RIGHT
	call z,&dv_adroite
	cp K_UP
	call z,&dv_enhaut
	cp K_SECOND
	ret z			;selectionner cette case
	cp K_EXIT
	call z,&exit
	jr deplacement_viseur
dv_enbas:
	push af
	ld a,c
	cp 54
	jr z,dv_enbas_pp	;ne peut pas descendre plus bas
	add a,6		;descendre le viseur d'une case
	ld c,a
	ld de,10
	add hl,de	;pointer hl sur la case en dessous dans le label(&grille_a ou &grille_b) soit 10 bytes plus loin
	push hl
	ld a,(case)
	add a,10
	ld (case),a
	ld a,(let)
	inc a
	ld (let),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir			;effacer le viseur 
	pop bc			;remettre les coordonns de la case dans bc
	call &put_viseur
	pop hl
dv_enbas_pp:
	pop af
	ret
dv_enhaut:
	push af
	ld a,c
	or a
	jr z,dv_enhaut_pp
	sub 6
	ld c,a
	ld de,10
	or a
	sbc hl,de
	push hl
	ld a,(case)
	sub 10
	ld (case),a
	ld a,(let)
	dec a
	ld (let),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop bc
	call &put_viseur
	pop hl
dv_enhaut_pp:
	pop af
	ret
dv_adroite:
	push af
	ld a,b
	cp 54
	jr z,dv_adroite_pp
	cp 120
	jr z,dv_adroite_pp
	add a,6
	ld b,a
	inc hl
	push hl
	ld a,(case)
	inc a
	ld (case),a
	ld a,(chif)
	inc a
	ld (chif),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop bc
	call &put_viseur
	pop hl
dv_adroite_pp:
	pop af
	ret
dv_agauche:
	push af
	ld a,b
	or a
	jr z,dv_agauche_pp
	cp 66
	jr z,dv_agauche_pp
	sub 6
	ld b,a
	dec hl
	push hl
	ld a,(case)
	dec a
	ld (case),a
	ld a,(chif)
	dec a
	ld (chif),a
	push bc
	ld hl,GRAPH_MEM
	ld de,VIDEO_MEM
	ld bc,944
	ldir
	pop bc
	call &put_viseur
	pop hl
dv_agauche_pp:
	pop af
	ret
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
affichage:		;affiche les grilles stock  hl
	push hl
	push hl
	call CLEARLCD
	ld de,0
	ld (let),de
	ld (chif),de
	pop hl
	ld bc,0	; coordonn de la 1er case en haut a gauche


affichage_sprite:
	ld a,(hl)
	or a
	call z,&sprite_vide
	cp 1
	call z,&sprite_dansleau
	cp 2
	call z,&sprite_touche
	cp 3
	call nc,&sprite_bateau	; si a est > ou =  3 affiche une case bateau
	ld a,b
	cp 54
	jr z,ligne_suivante
	cp 120
	jr z,ligne_suivante
	add a,6
	ld b,a
	inc hl
	jr affichage_sprite
ligne_suivante:
	ld a,c
	cp 54
	jr z,grille_suivante
	add a,6
	ld c,a
	ld a,b
	sub 54
	ld b,a
	inc hl
	jr affichage_sprite
grille_suivante:
	ld a,b
	cp 120
	jr z,affichage_fin
	ld bc,$4200
	inc hl
	jr affichage_sprite
affichage_fin:
	ld hl,VIDEO_MEM		;copie l'ecran dans la graph_mem
	ld de,GRAPH_MEM
	ld bc,944
	ldir
	pop hl
	ld bc,0
	ret		;fin du sous-programme d'affichage des grilles
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sprite_dansleau:
	push af
	push hl
	ld hl,&dansleau
	call &PutSprite
	pop hl
	pop af
	ret
sprite_touche:
	push af
	push hl
	ld hl,&touche
	call &PutSprite
	pop hl
	pop af
	ret
sprite_bateau:
	push af
	push hl
	ld hl,&bateau
	call &PutSprite
	pop hl
	pop af
	ret
sprite_vide:
	push af
	push hl
	ld hl,&vide
	call &PutSprite
	pop hl
	pop af
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;putsprite routine de l'usgard school
PutSprite: ; Puts a sprite pointed to by HL at B,C
         push bc
         push de
         ld a,63
         sub c
         ld c,a
         push hl
         push hl
         call FIND_PIXEL
         ld de,$FC00
         add hl,de
         ex de,hl
         pop hl
         ld b,(hl)
         inc hl
         ld c,(hl)
         inc hl
         push hl
         pop ix
         ex de,hl
PS_NewRow:
         push bc
         ld d,(ix)
         inc ix
         push af
         push hl
PS_NewCol:
         rl d
         ld e,a
         jr nc,PS_NoPixel
         or (hl)
         jr PS_NextPixel
PS_NoPixel:
         cpl
         and (hl)
PS_NextPixel:
         ld (hl),a
         ld a,e
         rrca
         jr nc,PS_SameByte
         inc hl
PS_SameByte:
         djnz PS_NewCol
         pop hl
         pop af
         ld de,16
         add hl,de
         pop bc
         dec c
         jr nz,PS_NewRow
         pop hl
         pop de
         pop bc
         ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;string + data location + sprites et image

tour:
	.db 3,$00,$00		;0=joueur 1;1=joueur2;3=pas de partie chargeable;$00=emplacment pour le code a;$00=emplacement pour le code b
	.db 3,3	; nombre d'essais restant pour le code
bateau_par_default:	;1:porte-avion(5 cases),2:cuirass(4 cases),3:croiser(...),4:sous-marin,5:destroyer
	.db 5,4,3,3,2
	.db 5,4,3,3,2

grille_a:				;0 : vide
	.db 0,0,0,0,0,0,0,0,0,0		;1 : un coup dans l'eau
	.db 0,0,0,0,0,0,0,0,0,0		;2 : touch
	.db 0,0,0,0,0,0,0,0,0,0		;3 : porte-avion
	.db 0,0,0,0,0,0,0,0,0,0		;4 : cuirass
	.db 0,0,0,0,0,0,0,0,0,0		;5 : croiser
	.db 0,0,0,0,0,0,0,0,0,0		;6 : sous-marin
	.db 0,0,0,0,0,0,0,0,0,0		;7 : destroyer
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0

grille_tir_a:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0



grille_b:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0

grille_tir_b:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0

bateau_a:		;nb de cases restantes pour chaque bateau
	.db 5,4,3,3,2

bateau_b:
	.db 5,4,3,3,2

joueura:
	.db "JOUEUR A",0
joueurb:
	.db "JOUEUR B",0
presskeycodeS:
	.db "Appuie sur la touche ",0
	.db "qui sera ton code.   ",0
entercodeS:
	.db "Tape ton code, mais  "
	.db 0					;je met le zero ici parce que a merde sinon 
	.db "tu n'as que 3 essais "	;il m'affiche le texte d'aprs
	.db 0
	.db "dans toute la partie "
	.db 0
	.db "sinon elle est foutue"
	.db 0
	.db "nb d'essais restants:"
	.db 0
winS:
	.db "BRAVO,T'AS GAGNE!"
	.db 0
codecorrectS:
	.db "CODE EXACT",0
premiere_caseS:
	.db "Choisie la 1er case du bateau:",0
doubS:
	.db "Vers la droite ou Vers le bas?",0
cibleS:
	.db "Quelle est la cible?",0
dansleauS:
	.db "Dans l'eau!"
	.db 0
toucheS:
	.db "TOUCHE!",0
couleS:
	.db " et COULE!",0
porteS:
	.db "PORTE-AVION(5)",0
cuirasseS:
	.db "CUIRASSE(4)",0
croiserS:
	.db "CROISER(3)",0
sousS:
	.db "SOUS-MARIN(3)",0
destroyerS:
	.db "DESTROYER(2)",0
titreS:
	.db "TOUCHE COULE v2.2",0
	.db "F1-NEW      F5-RESUME",0
lettres:
	.db 'A','B','C','D','E','F','G','H','I','J'
chiffres:
	.db 1,2,3,4,5,6,7,8,9,10
dansleau:
	.db 8,6
	.db %11000110
	.db %10101010
	.db %10010010
	.db %10101010
	.db %11000110
	.db %11111111
touche:
	.db 8,6
	.db %10010010
	.db %10111010
	.db %11111110
	.db %10111010
	.db %10010010
	.db %11111111
bateau:
	.db 8,6
	.db %10010010
	.db %10101010
	.db %11000110
	.db %10101010
	.db %10010010
	.db %11111111
viseur:
	.db 8,5
	.db %00111000
	.db %01010100
	.db %01111100
	.db %01010100
	.db %00111000
vide:
	.db 8,6
	.db %10000010
	.db %10000010
	.db %10000010
	.db %10000010
	.db %10000010
	.db %11111111
 
.end        ;et voila c'est fini!

